<template>
  <div class="admin-popup p-2 pl-6 pb-4 rounded-16 bg-bgdtert fixed top-6 right-6 z-30">
    <div class="flex items-center justify-between">
      <p class="text-txtdprim font-bold text-xl">
        <span v-if="adminPopupStatus === 'error'">Error</span>
        <span v-else-if="adminPopupStatus === 'warn'">Warning</span>
        <span v-else>Information</span>
      </p>
      <UiButton button-height="none" color-type="secondary" class="w-10 h-10 rounded-12" @click="closePopup">
        <img width="24" height="24" src="@/assets/images/ui/ui-cross.svg" />
      </UiButton>
    </div>
    <div class="text-txtdsec mt-2 font-medium">{{ adminPopupText }}</div>
  </div>
</template>

<script lang="ts">
import UiButton from '@/components/ui/UiButton.vue';

export default {
  name: 'AdminPopup',

  components: { UiButton },

  data() {
    return {
      closeTimeout: null,
    };
  },

  computed: {
    adminPopupDisplay() {
      return this.$store.state.system.popupDisplay;
    },

    adminPopupStatus() {
      return this.$store.state.system.popupInfoStatus;
    },

    adminPopupText() {
      return this.$store.state.system.popupInfo;
    },
  },

  watch: {
    adminPopupDisplay() {
      if (this.closeTimeout) clearTimeout(this.closeTimeout);
      this.closeTimeout = setTimeout(() => {
        this.$store.dispatch('setPopupDisplay', { display: false });
      }, 10000);
    },
  },

  methods: {
    closePopup() {
      clearTimeout(this.closeTimeout);
      this.$store.dispatch('setPopupDisplay', { display: false });
    },
  },
};
</script>

<style lang="scss">
.admin-popup {
  box-shadow: 0px 2px 8px 0px #00000026;
  width: 350px;
}
</style>
